MONGOD(1)

NAME
mongod - MongoDB Server

SYNOPSIS

mongod is the primary daemon process for the MongoDB system. It handles data requests, manages data access, and performs background management operations.

This document provides a complete overview of all command line options for mongod. These command line options are primarily useful for testing: In common operation, use the configuration file options to control the behavior of your database.

OPTIONS

  Core Options

mongod

--help, -h
    Returns information on the options and use of mongod.

--version
    Returns the mongod release number.

--config <filename>, -f <filename>
    Specifies a configuration file for runtime configuration options. The configuration file is the preferred method for runtime configuration of mongod. The options are equivalent to the command-line configuration options. See http://docs.mongodb.org/manual/reference/configuration-options for more information.

    Ensure the configuration file uses ASCII encoding. The mongod instance does not support configuration files with non-ASCII encoding, including UTF-8.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--quiet
    Runs the mongod in a quiet mode that attempts to limit the amount of output.

    This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--port <port>
    Default: 27017

    Specifies the TCP port on which the MongoDB instance listens for client connections.

--bind_ip <ip address>
    Default: All interfaces.

    Changed in version 2.6.0: The deb and rpm packages include a default configuration file that sets --bind_ip to 127.0.0.1.

    Specifies the IP address that mongod binds to in order to listen for connections from applications. You may attach mongod to any interface. When attaching mongod to a publicly accessible interface, ensure that you have implemented proper authentication and firewall restrictions to protect the integrity of your database.

--maxConns <number>
    The maximum number of simultaneous connections that mongod will accept. This setting has no effect if it is higher than your operating system's configured maximum connection tracking threshold.

    Changed in version 2.6: MongoDB removed the upward limit on the maxIncomingConnections setting.

--syslog
    Sends all logging output to the host's syslog system rather than to standard output or to a log file. , as with --logpath.

    The --syslog option is not supported on Windows.

--syslogFacility <string>
    Default: user

    Specifies the facility level used when logging messages to syslog. The value you specify must be supported by your operating system's implementation of syslog. To use this option, you must enable the --syslog option.

--logpath <path>
    Sends all diagnostic logging information to a log file instead of to standard output or to the host's syslog system. MongoDB creates the log file at the path you specify.

    By default, MongoDB overwrites the log file when the process restarts. To instead append to the log file, set the --logappend option.

--logappend
    Appends new entries to the end of the log file rather than overwriting the content of the log when the mongod instance restarts.

--logRotate <string>
    Default: rename

    New in version 3.0.0: Specifies the logRotate behavior.

    Specify either rename or reopen.

    rename renames the log file.

    reopen closes and reopens the log file following the typical Linux/Unix log rotate behavior. Use reopen when using the Linux/Unix logrotate utility to avoid log loss.

    If you specify reopen, you must also use --logappend.

    SEE ALSO: http://docs.mongodb.org/manual/reference/command/logRotate.

--timeStampFormat <string>
    Default: iso8601-local

    The time format for timestamps in log messages. Specify one of the following values:
    Value | Description
    ctime | Displays timestamps as Wed Dec 31 18:17:54.811.
    iso8601-utc | Displays timestamps in Coordinated Universal Time (UTC) in the ISO-8601 format. For example, for New York at the start of the Epoch: 1970-01-01T00:00:00.000Z
    iso8601-local | Displays timestamps in local time in the ISO-8601 format. For example, for New York at the start of the Epoch: 1969-12-31T19:00:00.000+0500

--diaglog <value>
    Default: 0

    Deprecated since version 2.6.

    --diaglog is for internal use and not intended for most users.

    Creates a very verbose diagnostic log for troubleshooting and recording various errors. MongoDB writes these log files in the dbPath directory in a series of files that begin with the string diaglog and end with the initiation time of the logging as a hex string.

    The specified value configures the level of verbosity:
    Value | Setting
    0 | Off. No logging.
    1 | Log write operations.
    2 | Log read operations.
    3 | Log both read and write operations.
    7 | Log write and some read operations.

    You can use the mongosniff tool to replay this output for investigation. Given a typical diaglog file located at /var/mongodb/diaglog.4f76a58c, you might use a command in the following form to read these files:

    mongosniff --source DIAGLOG /var/mongodb/diaglog.4f76a58c

    WARNING: Setting the diagnostic level to 0 will cause mongod to stop writing data to the diagnostic log file. However, the mongod instance will continue to keep the file open, even if it is no longer writing data to the file. If you want to rename, move, or delete the diagnostic log you must cleanly shut down the mongod instance before doing so.

--traceExceptions
    For internal diagnostic use only.

--pidfilepath <path>
    Specifies a file location to hold the process ID of the mongod process where mongod will write its PID. This is useful for tracking the mongod process in combination with the --fork option. Without a specified --pidfilepath option, the process creates no PID file.

--keyFile <file>
    Specifies the path to a key file that stores the shared secret that MongoDB instances use to authenticate to each other in a sharded cluster or replica set. --keyFile implies --auth. See inter-process-auth for more information.

--setParameter <options>
    Specifies one of the MongoDB parameters described in http://docs.mongodb.org/manual/reference/parameters. You can specify multiple setParameter fields.

--httpinterface
    New in version 2.6.

    Enables the HTTP interface. Enabling the interface can increase network exposure.

    Leave the HTTP interface disabled for production deployments. If you do enable this interface, you should only allow trusted clients to access this port. See security-firewalls.

    NOTE: In MongoDB Enterprise, the HTTP Console does not support Kerberos Authentication.

--nohttpinterface
    Deprecated since version 2.6: MongoDB disables the HTTP interface by default.

    Disables the HTTP interface.

    Do not use in conjunction with --rest or --jsonp.

    NOTE: In MongoDB Enterprise, the HTTP Console does not support Kerberos Authentication.

--nounixsocket
    Disables listening on the UNIX domain socket. The mongod process always listens on the UNIX socket unless one of the following is true:

•   --nounixsocket is set

•   bindIp is not set

•   bindIp does not specify 127.0.0.1

    New in version 2.6: mongod installed from official .deb and .rpm packages have the bind_ip configuration set to 127.0.0.1 by default.

--unixSocketPrefix <path>
    Default: /tmp

    The path for the UNIX socket. If this option has no value, the mongod process creates a socket with /tmp as a prefix. MongoDB creates and listens on a UNIX socket unless one of the following is true:

•   --nounixsocket is set

•   bindIp is not set

•   bindIp does not specify 127.0.0.1

--fork
    Enables a daemon mode that runs the mongod process in the background. By default mongod does not run as a daemon: typically you will run mongod as a daemon, either by using --fork or by using a controlling process that handles the daemonization process (e.g. as with upstart and systemd).

--auth
    Enables authorization to control user's access to database resources and operations. When authorization is enabled, MongoDB requires all clients to authenticate themselves first in order to determine the access for the client.

    Configure users via the mongo shell. If no users exist, the localhost interface will continue to have access to the database until you create the first user.

    See Security for more information.

--noauth
    Disables authentication. Currently the default. Exists for future compatibility and clarity.

--ipv6
    Enables IPv6 support and allows the mongod to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes disable IPv6 support by default.

--jsonp
    Permits JSONP access via an HTTP interface. Enabling the interface can increase network exposure. The --jsonp option enables the HTTP interface, even if the HTTP interface option is disabled.

--rest
    Enables the simple REST API. Enabling the REST API enables the HTTP interface, even if the HTTP interface option is disabled, and as a result can increase network exposure.

--slowms <integer>
    Default: 100

    The threshold in milliseconds at which the database profiler considers a query slow. MongoDB records all slow queries to the log, even when the database profiler is off. When the profiler is on, it writes to the system.profile collection. See the profile command for more information on the database profiler.

--profile <level>
    Default: 0

    Changes the level of database profiling, which inserts information about operation performance into standard output or a log file. Specify one of the following levels:
    Level | Setting
    0 | Off. No profiling.
    1 | On. Only includes slow operations.
    2 | On. Includes all operations.

    Database profiling can impact database performance. Enable this option only after careful consideration.

--cpu
    Forces the mongod process to report the percentage of CPU time in write lock, every four seconds.

--sysinfo
    Returns diagnostic system information and then exits. The information provides the page size, the number of physical pages, and the number of available physical pages.

--objcheck
    Forces the mongod to validate all requests from clients upon receipt to ensure that clients never insert invalid documents into the database. For objects with a high degree of sub-document nesting, the --objcheck option can have a small impact on performance. You can set --noobjcheck to disable object checking at runtime.

    Changed in version 2.4: MongoDB enables the --objcheck option by default in order to prevent any client from inserting malformed or invalid BSON into a MongoDB database.

--noobjcheck
    New in version 2.4.

    Disables the default document validation that MongoDB performs on all incoming BSON documents.

--noscripting
    Disables the scripting engine.

--notablescan
    Forbids operations that require a table scan. See notablescan for additional information.

--shutdown
    The --shutdown option cleanly and safely terminates the mongod process. When invoking mongod with this option you must set the --dbpath option either directly or by way of the configuration file and the --config option.

    The --shutdown option is available only on Linux systems.

  Storage Options

--dbpath <path>
    Default: /var/mongodb on Linux and OS X, \data\db on Windows

    The directory where the mongod instance stores its data.

    If you installed MongoDB using a package management system, check the /usr/pkg/etc/mongodb.conf file provided by your packages to see the directory is specified.

    Changed in version 3.0: The files in --dbpath must correspond to the storage engine specified in --storageEngine. If the data files do not correspond to --storageEngine, mongod will refuse to start.

--storageEngine string
    Default: mmapv1

    New in version 3.0.0.

    Specifies the storage engine for the mongod database. Valid options include mmapv1 and wiredTiger.

    If you attempt to start a mongod with a storage.dbPath that contains data files produced by a storage engine other than the one specified by --storageEngine, mongod will refuse to start.

--wiredTigerDirectoryForIndexes
    Type: boolean

    Default: false

    New in version 3.0.0.

    When you start mongod with --wiredTigerDirectoryForIndexes, mongod stores indexes and collections in separate directories.

--wiredTigerCacheSizeGB number
    Default: the maximum of half of physical RAM or 1 gigabyte

    New in version 3.0.0.

    Defines the maximum size of the cache that WiredTiger will use for all data. Ensure that --wiredTigerCacheSizeGB is sufficient to hold the entire working set for the mongod instance.

--wiredTigerCheckpointDelaySecs <seconds>
    Default: 60

    New in version 3.0.0.

    Defines the interval between checkpoints when WiredTiger writes all modified data to the data files in dbPath. If the mongod exits between checkpoints and you do not have storage.journal.enabled set to true, any data modified since the last checkpoint will not persist. The data files are always valid even if mongod exits between or during a checkpoint.

--wiredTigerStatisticsLogDelaySecs <seconds>
    Default: 0

    New in version 3.0.0.

    When 0 WiredTiger will not log statistics. Otherwise WiredTiger will log statistics to a file in the dbPath on the interval defined by --wiredTigerStatisticsLogDelaySecs.

--wiredTigerJournalCompressor <compressor>
    Default: snappy

    New in version 3.0.0.

    Specifies the type of compression to use to compress the journal data (i.e. storage.journal.)

    Available compressors are:

•   none

•   snappy

•   zlib

--wiredTigerCollectionBlockCompressor <compressor>
    Default: none

    New in version 3.0.0.

    Specifies the default type of compression to use to compress index data. You can override this on a per-index basis when creating indexes.

    Available compressors are:

•   none

•   snappy

•   zlib

--wiredTigerIndexPrefixCompression <boolean>
    Default: true

    New in version 3.0.0.

    Specify true for --wiredTigerIndexPrefixCompression to enable prefix compression for index data.

--directoryperdb
    Stores each database's files in its own folder in the data directory. When applied to an existing system, the --directoryperdb option alters the storage pattern of the data directory.

    Use this option in conjunction with your file system and device configuration so that MongoDB will store data on a number of distinct disk devices to increase write throughput or disk capacity.

    WARNING: To enable this option for an existing system, migrate the database-specific data files to the new directory structure before enabling --directoryperdb. Database-specific data files begin with the name of an existing database and end with either "ns" or a number. For example, the following data directory includes files for the local and test databases:

    journal
    mongod.lock
    local.0
    local.1
    local.ns
    test.0
    test.1
    test.ns

    After migration, the data directory would have the following structure:

    journal
    mongod.lock
    local/local.0
    local/local.1
    local/local.ns
    test/test.0
    test/test.1
    test/test.ns

--noIndexBuildRetry
    Stops the mongod from rebuilding incomplete indexes on the next start up. This applies in cases where the mongod restarts after it has shut down or stopped in the middle of an index build. In such cases, the mongod always removes any incomplete indexes, and then also, by default, attempts to rebuild them. To stop the mongod from rebuilding incomplete indexes on start up, include this option on the command-line.

--noprealloc
    Deprecated since version 2.6.

    Disables the preallocation of data files. Currently the default. Exists for future compatibility and clarity.

--nssize <value>
    Default: 16

    Specifies the default size for namespace files, which are files that end in .ns. Each collection and index counts as a namespace.

    Use this setting to control size for newly created namespace files. This option has no impact on existing files. The maximum size for a namespace file is 2047 megabytes. The default value of 16 megabytes provides for approximately 24,000 namespaces.

--quota
    Enables a maximum limit for the number data files each database can have. When running with the --quota option, MongoDB has a maximum of 8 data files per database. Adjust the quota with --quotaFiles.

--quotaFiles <number>
    Default: 8

    Modifies the limit on the number of data files per database. --quotaFiles option requires that you set --quota.

--smallfiles
    Sets MongoDB to use a smaller default file size. The --smallfiles option reduces the initial size for data files and limits the maximum size to 512 megabytes. --smallfiles also reduces the size of each journal file from 1 gigabyte to 128 megabytes. Use --smallfiles if you have a large number of databases that each holds a small quantity of data.

    The --smallfiles option can lead the mongod instance to create a large number of files, which can affect performance for larger databases.

--syncdelay <value>
    Default: 60

    Controls how much time can pass before MongoDB flushes data to the data files via an fsync operation. Do not set this value on production systems. In almost every situation, you should use the default setting.

    WARNING: If you set --syncdelay to 0, MongoDB will not sync the memory mapped files to disk.

    The mongod process writes data very quickly to the journal and lazily to the data files. syncPeriodSecs has no effect on the journal files or journaling.

    The serverStatus command reports the background flush thread's status via the backgroundFlushing field.

--upgrade
    Upgrades the on-disk data format of the files specified by the --dbpath to the latest version, if needed.

    This option only affects the operation of the mongod if the data files are in an old format.

    In most cases you should not set this value, so you can exercise the most control over your upgrade process. See the MongoDB release notes (on the download page) for more information about the upgrade process.

--repair
    Runs a repair routine on all databases. This is equivalent to shutting down and running the repairDatabase database command on all databases.

    WARNING: During normal operations, only use the repairDatabase command and wrappers including db.repairDatabase() in the mongo shell and mongod --repair, to compact database files and/or reclaim disk space. Be aware that these operations remove and do not save any corrupt data during the repair process.

    If you are trying to repair a replica set member, and you have access to an intact copy of your data (e.g. a recent backup or an intact member of the replica set), you should restore from that intact copy, and not use repairDatabase.

    When using journaling, there is almost never any need to run repairDatabase. In the event of an unclean shutdown, the server will be able to restore the data files to a pristine state automatically.

    Changed in version 2.1.2.

    If you run the repair option and have data in a journal file, the mongod instance refuses to start. In these cases you should start the mongod without the --repair option, which allows the mongod to recover data from the journal. This completes more quickly and is more likely to produce valid data files. To continue the repair operation despite the journal files, shut down the mongod cleanly and restart with the --repair option.

    The --repair option copies data from the source data files into new data files in the repairPath and then replaces the original data files with the repaired data files.

--repairpath <path>
    Default: A _tmp directory within the path specified by the dbPath option.

    Specifies a working directory that MongoDB will use during the --repair operation. After --repair completes, the data files in dbPath and the --repairpath directory is empty.

    The --repairpath must be within the dbPath. You can specify a symlink to --repairpath to use a path on a different file system.

--journal
    Enables the durability journal to ensure data files remain valid and recoverable. This option applies only when you specify the --dbpath option. The mongod enables journaling by default on 64-bit builds of versions after 2.0.

--nojournal
    Disables the durability journaling. The mongod instance enables journaling by default in 64-bit versions after v2.0.

--journalOptions <arguments>
    Provides functionality for testing. Not for general use, and will affect data file integrity in the case of abnormal system shutdown.

--journalCommitInterval <value>
    Default: 100 or 30

    The maximum amount of time the mongod process allows between journal operations. Values can range from 2 to 300 milliseconds. Lower values increase the durability of the journal, at the expense of disk performance.

    The default journal commit interval is 100 milliseconds if a single block device (e.g. physical volume, RAID device, or LVM volume) contains both the journal and the data files.

    If the journal is on a different block device than the data files the default journal commit interval is 30 milliseconds.

    To force mongod to commit to the journal more frequently, you can specify j:true. When a write operation with j:true is pending, mongod will reduce commitIntervalMs to a third of the set value.

  Replication Options

--replSet <setname>
    Configures replication. Specify a replica set name as an argument to this set. All hosts in the replica set must have the same set name.

    If your application connects to more than one replica set, each set should have a distinct name. Some drivers group replica set connections by replica set name.

--oplogSize <value>
    Specifies a maximum size in megabytes for the replication operation log (i.e., the oplog). The mongod process creates an oplog based on the maximum amount of space available. For 64-bit systems, the oplog is typically 5% of available disk space. Once the mongod has created the oplog for the first time, changing the --oplogSize option will not affect the size of the oplog.

    See replica-set-oplog-sizing for more information.

--replIndexPrefetch
    Default: all

    New in version 2.2.

Storage Engine Specific Feature

    --replIndexPrefetch is only available with the mmapv1 storage engine.

    Determines which indexes secondary members of a replica set load into memory before applying operations from the oplog. By default secondaries load all indexes related to an operation into memory before applying operations from the oplog. This option can have one of the following values:
    Value | Description
    none | Secondaries do not load indexes into memory.
    all | Secondaries load all indexes related to an operation.
    _id_only | Secondaries load no additional indexes into memory beyond the already existing _id index.

  Master-Slave Replication

These options provide access to conventional master-slave database replication. While this functionality remains accessible in MongoDB, replica sets are the preferred configuration for database replication.

--master
    Configures the mongod to run as a replication master.

--slave
    Configures the mongod to run as a replication slave.

--source <host><:port>
    For use with the --slave option, the --source option designates the server that this instance will replicate.

--only <arg>
    For use with the --slave option, the --only option specifies only a single database to replicate.

--slavedelay <value>
    For use with the --slave option, the --slavedelay option configures a "delay" in seconds, for this slave to wait to apply operations from the master node.

--autoresync
    For use with the --slave option. When set, the --autoresync option allows this slave to automatically resync if it is more than 10 seconds behind the master. This setting may be problematic if the --oplogSize specifies a too small oplog.

    If the oplog is not large enough to store the difference in changes between the master's current state and the state of the slave, this instance will forcibly resync itself unnecessarily. If you don't specify --autoresync, the slave will not attempt an automatic resync more than once in a ten minute period.

--fastsync
    In the context of replica set replication, set this option if you have seeded this member with an up-to-date copy of the entire dbPath of another member of the set. Otherwise the mongod will attempt to perform an initial sync, as though the member were a new member.

    WARNING: If the data is not perfectly synchronized and the mongod starts with fastsync, then the secondary or slave will be permanently out of sync with the primary, which may cause significant consistency problems.

  Sharded Cluster Options

--configsvr
    Declares that this mongod instance serves as the config database of a sharded cluster. When running with this option, clients (i.e. other cluster components) will not be able to write data to any database other than config and admin. The default port for a mongod with this option is 27019 and the default --dbpath directory is /var/mongoconfigdb, unless specified.

    Changed in version 2.2: The --configsvr option also sets --smallfiles.

    Changed in version 2.4: The --configsvr option creates a local oplog.

    Do not use the --configsvr option with --replSet or --shardsvr. Config servers cannot be a shard server or part of a replica set.

--shardsvr
    Configures this mongod instance as a shard in a partitioned cluster. The default port for these instances is 27018. The only effect of --shardsvr is to change the port number.

  SSL Options

  See

http://docs.mongodb.org/manual/tutorial/configure-ssl for full documentation of MongoDB's support.

--sslOnNormalPorts
    Deprecated since version 2.6.

    Enables SSL for mongod.

    With --sslOnNormalPorts, a mongod requires SSL encryption for all connections on the default MongoDB port, or the port specified by --port. By default, --sslOnNormalPorts is disabled.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslMode <mode>
    New in version 2.6.

    Enables SSL or mixed SSL used for all network connections. The argument to the --sslMode option can be one of the following:
    Value | Description
    disabled | The server does not use SSL.
    allowSSL | Connections between servers do not use SSL. For incoming connections, the server accepts both SSL and non-SSL.
    preferSSL | Connections between servers use SSL. For incoming connections, the server accepts both SSL and non-SSL.
    requireSSL | The server uses and accepts only SSL encrypted connections.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyFile <filename>
    New in version 2.2.

    Specifies the .pem file that contains both the SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    When SSL is enabled, you must specify --sslPEMKeyFile.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyPassword <value>
    New in version 2.2.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongod will redact the password from all logging and reporting output.

    Changed in version 2.6: If the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, the mongod will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--clusterAuthMode <option>
    Default: keyFile

    New in version 2.6.

    The authentication mode used for cluster authentication. If you use internal x.509 authentication, specify so here. This option can have one of the following values:
    Value | Description
    keyFile | Use a keyfile for authentication. Accept only keyfiles.
    sendKeyFile | For rolling upgrade purposes. Send a keyfile for authentication but can accept both keyfiles and x.509 certificates.
    sendX509 | For rolling upgrade purposes. Send the x.509 certificate for authentication but can accept both keyfiles and x.509 certificates.
    x509 | Recommended. Send the x.509 certificate for authentication and accept only x.509 certificates.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslClusterFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the x.509 certificate-key file for membership authentication for the cluster or replica set.

    If --sslClusterFile does not specify the .pem file for internal cluster authentication, the cluster uses the .pem file specified in the --sslPEMKeyFile option.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslClusterPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the x.509 certificate-key file specified with --sslClusterFile. Use the --sslClusterPassword option only if the certificate-key file is encrypted. In all cases, the mongod will redact the password from all logging and reporting output.

    If the x.509 key file is encrypted and you do not specify the --sslClusterPassword option, the mongod will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCAFile <filename>
    New in version 2.4.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

    WARNING: If the --sslCAFile option and its target file are not specified, x.509 client and member authentication will not function. mongod, and mongos in sharded systems, will not be able to verify the certificates of processes connecting to it against the trusted certificate authority (CA) that issued them, breaking the certificate chain.

    As of version 2.6.4, mongod will not start with x.509 authentication enabled if the CA file is not specified.

--sslCRLFile <filename>
    New in version 2.4.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for SSL certificates on other servers in the cluster and allows the use of invalid certificates. When using the allowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidHostnames
    New in version 3.0.

    Disables the validation of the hostnames in SSL certificates, when connecting to other mongod instances for inter-process authentication. This allows mongod to connect to other mongod instances if the hostnames in their certificates do not match their configured hostname.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowConnectionsWithoutCertificates
    New in version 2.4.

    Changed in version 3.0.0: --sslAllowConnectionsWithoutCertificates became --sslAllowConnectionsWithoutCertificates. For compatibility, MongoDB processes continue to accept --sslAllowConnectionsWithoutCertificates, but all users should update their configuration files.

    Disables the requirement for SSL certificate validation that --sslCAFile enables. With the --sslAllowConnectionsWithoutCertificates option, the mongod will accept connections when the client does not present a certificate when establishing the connection.

    If the client presents a certificate and the mongod has --sslAllowConnectionsWithoutCertificates enabled, the mongod will validate the certificate using the root certificate chain specified by --sslCAFile and reject clients with invalid certificates.

    Use the --sslAllowConnectionsWithoutCertificates option if you have a mixed deployment that includes clients that do not or cannot present certificates to the mongod.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslFIPSMode
    New in version 2.4.

    Directs the mongod to use the FIPS mode of the installed OpenSSL library. Your system must have a FIPS compliant OpenSSL library to use the --sslFIPSMode option.

    NOTE: FIPS Compatible SSL is available only in MongoDB Enterprise. See http://docs.mongodb.org/manual/tutorial/configure-fips for more information.

  Audit Options

--auditDestination
    New in version 2.6.

    Enables auditing. The --auditDestination option can have one of the following values:
    Value | Description
    syslog | Output the audit events to syslog in JSON format. Not available on Windows. Audit messages have a syslog severity level of info and a facility level of user. The syslog message limit can result in the truncation of audit messages. The auditing system will neither detect the truncation nor error upon its occurrence.
    console | Output the audit events to stdout in JSON format.
    file | Output the audit events to the file specified in --auditPath in the format specified in --auditFormat.

    NOTE: Available only in MongoDB Enterprise.

--auditFormat
    New in version 2.6.

    Specifies the format of the output file for auditing if --auditDestination is file. The --auditFormat option can have one of the following values:
    Value | Description
    JSON | Output the audit events in JSON format to the file specified in --auditPath.
    BSON | Output the audit events in BSON binary format to the file specified in --auditPath.

    Printing audit events to a file in JSON format degrades server performance more than printing to a file in BSON format.

    NOTE: Available only in MongoDB Enterprise.

--auditPath
    New in version 2.6.

    Specifies the output file for auditing if --auditDestination has value of file. The --auditPath option can take either a full path name or a relative path name.

    NOTE: Available only in MongoDB Enterprise.

--auditFilter
    New in version 2.6.

    Specifies the filter to limit the types of operations the audit system records. The option takes a string representation of a query document of the form:

    { <field1>: <expression1>, ... }

    The <field> can be any field in the audit message, including fields returned in the param document. The <expression> is a query condition expression.

    To specify an audit filter, enclose the filter document in single quotes to pass the document as a string.

    To specify the audit filter in a configuration file, you must use the YAML format of the configuration file.

    NOTE: Available only in MongoDB Enterprise.

  SNMP Options

--snmp-subagent
    Runs SNMP as a subagent. For more information, see http://docs.mongodb.org/manual/tutorial/monitor-with-snmp.

--snmp-master
    Runs SNMP as a master. For more information, see http://docs.mongodb.org/manual/tutorial/monitor-with-snmp.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2015